import json
from os.path import join, dirname

from keras.callbacks import ReduceLROnPlateau, EarlyStopping, CSVLogger
from keras.preprocessing.image import ImageDataGenerator
from sklearn.model_selection import train_test_split
from keras.preprocessing.image import img_to_array
from keras.utils import to_categorical, plot_model
from imutils import paths
import numpy as np
import random
import cv2
import os
import matplotlib.pyplot as plt

from vgg import VGG

img_dim = (59, 59, 1)
densenet_depth = 40
densenet_growth_rate = 12
batch_size = 32
nb_epoch = 50
data_augmentation = True

lr_reducer = ReduceLROnPlateau(factor=np.sqrt(0.1), cooldown=0, patience=5, min_lr=0.5e-6)
early_stopper = EarlyStopping(min_delta=0.001, patience=10)
csv_logger = CSVLogger('analyze/vgg.log.csv')

print("Loading images...")
data = []
labels = []
dir_labels = ()
num_class = 0
cwd = os.getcwd()
dataset = cwd.replace("/egs/vgg", "/dataset/images/train")
save_model = join(dirname(__file__), "model", "model.bin")

print("[INFO] Finding Labels...")
for file in os.listdir(dataset):
    temp_tuple = (file, 'null')
    dir_labels = dir_labels + temp_tuple
    dir_labels = dir_labels[:-1]
    num_class = num_class + 1

image_paths = sorted(list(paths.list_images(dataset)))
random.seed(42)
random.shuffle(image_paths)

for image_path in image_paths:
    image = cv2.imread(image_path, 0)
    # image = cv2.resize(image, (32, 32))
    image = img_to_array(image)
    data.append(image)

    # extract the class label from the png path and update the labels list
    label = image_path.split(os.path.sep)[-2]
    for i in range(num_class):
        if label == dir_labels[i]:
            name = image_path.split("/")[-2]
            label = {"id": i, "name": name}
    labels.append(label)
label_id = list({v['id']: v for v in labels}.values())
with open("model/label_id.json", "w") as f:
    json.dump(label_id, f)
data = np.array(data, dtype="float") / 255.0
labels = np.array([i["id"] for i in labels])
(X_train, X_test, y_train, y_test) = train_test_split(data, labels,
                                                      test_size=0.2,
                                                      random_state=42,
                                                      shuffle=True)

y_train = to_categorical(y_train, num_classes=num_class)
y_test = to_categorical(y_test, num_classes=num_class)


num_class = len(list(set(labels)))
model = VGG.build_model(59, 59, 1, num_class)
model.compile(loss='categorical_crossentropy',
              optimizer='adam',
              metrics=['accuracy'])

print('Using real-time data augmentation.')
# This will do preprocessing and realtime data augmentation:
datagen = ImageDataGenerator(
    featurewise_center=False,  # set input mean to 0 over the dataset
    samplewise_center=False,  # set each sample mean to 0
    featurewise_std_normalization=False,  # divide inputs by std of the dataset
    samplewise_std_normalization=False,  # divide each input by its std
    zca_whitening=False,  # apply ZCA whitening
    rotation_range=0,  # randomly rotate images in the range (degrees, 0 to 180)
    width_shift_range=0.1,  # randomly shift images horizontally (fraction of total width)
    height_shift_range=0.1,  # randomly shift images vertically (fraction of total height)
    horizontal_flip=True,  # randomly flip images
    vertical_flip=False)  # randomly flip images

# Compute quantities required for featurewise normalization
# (std, mean, and principal components if ZCA whitening is applied).
datagen.fit(X_train)

# Fit the model on the batches generated by datagen.flow().
H = model.fit_generator(datagen.flow(X_train, y_train, batch_size=batch_size),
                        steps_per_epoch=X_train.shape[0] // batch_size,
                        validation_data=(X_test, y_test),
                        epochs=nb_epoch, verbose=1, max_q_size=100,
                        callbacks=[lr_reducer, early_stopper, csv_logger])
print("Serializing network...")
model.save(save_model)
plot_model(model, to_file='analyze/model_plot.png', show_shapes=True, show_layer_names=True)

plt.style.use("ggplot")
plt.figure()

plt.title("Training Accuracy")
plt.plot(np.arange(0, nb_epoch), H.history["acc"], label="train_acc", marker='o')
plt.plot(np.arange(0, nb_epoch), H.history["val_acc"], label="val_acc", marker='^')
plt.xlabel("Epoch #")
plt.ylabel("Accuracy")
plt.legend(loc="lower left")
plt.savefig("analyze/train_accuracy.png")

plt.style.use("ggplot")
plt.figure()

plt.title("Training Loss")
plt.plot(np.arange(0, nb_epoch), H.history["loss"], label="train_loss", marker='o')
plt.plot(np.arange(0, nb_epoch), H.history["val_loss"], label="val_loss", marker='^')
plt.xlabel("Epoch #")
plt.ylabel("Loss")
plt.legend(loc="lower left")
plt.savefig("analyze/train_loss.png")
